const loadingView = document.querySelector('.loadingView');

/* Tel */
var input = document.querySelector('#phone');
var country;
var ip;
var city;
var iti = intlTelInput(input, {
  hiddenInput: 'fulltel',
  nationalMode: true,
  initialCountry: 'auto',
  geoIpLookup: function (success, failure) {
    jQuery
      .get(
        'https://api.ipdata.co/?api-key=3b871d590f37c80589d2b25a7b53975c2d132d74a4a5395349ec5551',
        function () {},
        'jsonp',
      )
      .always(function (resp) {
        var countryCode = resp && resp.country_code ? resp.country_code : '';
        country = resp && resp.country_code ? resp.country_code : '';
        ip = resp && resp.ip ? resp.ip : '';
        city = resp && resp.city ? resp.city : '';
        jQuery('#ctry').val(country);
        success(countryCode);
        jQuery('#ctrlist select').val(resp.country_code);
      });
  },
});

/* URL */
$('#url').val(window.location.href);

/* Password */
function generatePassword() {
  var length = 8,
    charset = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',
    retVal = '';
  for (var i = 0, n = charset.length; i < length; ++i) {
    retVal += charset.charAt(Math.floor(Math.random() * n));
  }
  return retVal;
}
$('#password').val(generatePassword());

/* loader */
var x = $('#formbox');
var loader =
  '<div class="loading"><div class="lds-ellipsis"><div></div><div></div><div></div><div></div></div></div>';
x.innerHTML = x.innerHTML + loader;

/* URL */
function getParameterByName(name, url) {
  if (!url) url = window.location.href;
  name = name.replace(/[\[\]]/g, '\\$&');
  var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
    results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

/* Sesion User ID*/
function generate() {
  var chars = '123456789';

  var string_length = 7;
  var randomstring = '';
  for (var i = 0; i < string_length; i++) {
    var rnum = Math.floor(Math.random() * chars.length);
    randomstring += chars.substring(rnum, rnum + 1);
  }

  return randomstring + Math.floor(Math.random() * chars.length);
}

let st = localStorage.getItem('status');
let usid = localStorage.getItem('userid');
let id = st === 'lead' ? usid : generate();
let statusall = st === 'lead' ? st : 'guest';
let userid = {
  userid: id,
  status: statusall,
};
window.dataLayer = window.dataLayer || [];
window.dataLayer.push({ userId: userid });

/* Form sendiong*/
var formConf = {
  postback: true,
  postbackURL: 'example',
  redirectURL: './pages/thanks.php',
};
jQuery(document).ready(function () {
  jQuery(document).on('submit', '#formbox', function (e) {
    let submitBtn = document.querySelector('input[type=submit]');
    submitBtn.style.pointerEvents = 'none';
    submitBtn.style.opacity = '0.1';
    loadingView.style.display = 'block';
    if (!check.checked) {
      submitBtn.style.pointerEvents = 'all';
      submitBtn.style.opacity = '1';
      loadingView.style.display = 'none';
      jQuery('#check, #checklabel').addClass('error');
      return false; // don't submit
    }
    e.preventDefault();
    var fbclid = getParameterByName('fbclid');
    var site_source_name = getParameterByName('site_source_name');
    var source = getParameterByName('source');
    var placement = getParameterByName('placement');
    var ad_name = getParameterByName('ad_name');

    var ad_id = getParameterByName('ad_id');
    var adset_id = getParameterByName('adset_id');
    var profile = getParameterByName('profile');
    var campaign_id = getParameterByName('campaign_id');

    var device = navigator.userAgent;
    var postback = 0;
    var postbackURL = '';
    if (formConf.postback) {
      postback = 1;
      postbackURL = formConf.postbackURL;
    }
    jQuery('.loading').fadeIn();
    var full = iti.getNumber();
    jQuery('#fulltel').val(full);
    var fnameval = jQuery('#fname').val();
    var lnameval = jQuery('#lname').val();
    var emailval = jQuery('#email').val();
    var phoneval = full;
    var passval = jQuery('#password').val();
    var urlval = jQuery('#url').val();
    var ctryval = jQuery('#ctry').val();
    var clickid = jQuery('#mpc3').val();
    var data =
      'fname=' +
      fnameval +
      '&lname=' +
      lnameval +
      '&email=' +
      emailval +
      '&phone=' +
      phoneval +
      '&fbclid=' +
      fbclid +
      '&postback=' +
      postback +
      '&postbackurl=' +
      postbackURL +
      '&url=' +
      urlval +
      '&ctry=' +
      ctryval +
      '&city=' +
      city +
      '&ip=' +
      ip +
      '&password=' +
      passval +
      '&site_source_name=' +
      site_source_name +
      '&source=' +
      source +
      '&placement=' +
      placement +
      '&ad_name=' +
      ad_name +
      '&device=' +
      device +
      '&userid=' +
      userid.userid +
      '&clickid=' +
      clickid +
      '&ad_id=' +
      ad_id +
      '&adset_id=' +
      adset_id +
      '&profile=' +
      profile +
      '&campaign_id=' +
      campaign_id;
    jQuery.ajax({
      method: 'POST',
      crossDomain: true,
      url: './api/lead.php',
      data: data,
      cache: false,
      success: function (response) {
        var obj = jQuery.parseJSON(response);
        if (obj.status == 'success') {
          localStorage.setItem('userid', userid.userid);
          localStorage.setItem('status', userid.status);
          localStorage.setItem('encodeURL', encodeURI(obj.url));
          window.location.href = formConf.redirectURL;
        } else {
          submitBtn.style.pointerEvents = 'all';
          submitBtn.style.opacity = '1';
          jQuery('.loading').fadeOut();
          var errordiv = document.querySelector('#error-msg');
          errordiv.style.display = 'block';
          if ((errordiv.style.display = 'block')) {
            loadingView.style.display = 'none';
          }
          errordiv.innerHTML =
            'Su registro no tuvo éxito. ¡Asegúrese de que su dirección de correo electrónico y número de teléfono móvil sean correctos e inténtelo de nuevo!';
          //window.location.href =formConf.redirectURL;
        }
      },
    });
  });
});
